Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

WebLogic Server 6.0sp2 API Reference

## weblogic.apache.xerces.validators.common
Class SimpleContentModel

    java.lang.Object
      |
      +--weblogic.apache.xerces.validators.common.SimpleContentModel

public class SimpleContentModel
extends java.lang.Object
implements XMLContentModel

SimpleContentModel is a derivative of the abstract content model base class that handles a small set of simple content models that are just way overkill to give the DFA treatment.

This class handles the following scenarios:

- a
- a?
- a*
- a+
- a,b
- a|b

These all involve a unary operation with one element type, or a binary operation with two elements. These are very simple and can be checked in a simple way without a DFA and without the overhead of setting up a DFA for such a simple check.

This class is based on an implementation from the Apache XML Project. In future releases the XML parser, XSLT processor, and associated classes will likely be updated to be based on a later version of the Apache implementations. Since Apache does not guarantee backwards compatibility between versions of their software, we cannot guarantee backwards compatibility of any of the classes contained in the weblogic.apache package or sub-packages.

Version:
  $Id: SimpleContentModel.java,v 1.9 2000/08/10 02:57:42 ericye Exp $
Author:
  Copyright © 2001 BEA Systems, Inc. All Rights Reserved.

Constructor Summary
`SimpleContentModel(QName firstChild, QName secondChild, int cmOp)` Constructs a simple content model.
`SimpleContentModel(QName firstChild, QName secondChild, int cmOp, boolean dtd)` Constructs a simple content model.

Method Summary
`boolean` | `checkLastChildEndingState()`
`ContentLeafNameTypeVector` | `getContentLeafNameTypeVector()`
`void` | `setEquivClassComparator(EquivClassComparator comparator)`
`int` | `validateContent(QName[] children, int offset, int length)` Check that the specified content is valid according to this content model.
`int` | `validateContent(QName[] children, int offset, int length, boolean incomplete, int depth)`
`int` | `validateContentSpecial(QName[] children, int offset, int length)`
`int` | `whatCanGoHere(boolean fullyValid, InsertableElementsInfo info)` Returns information about which elements can be placed at a particular point in the passed element's content model.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SimpleContentModel

    public SimpleContentModel(QName firstChild,
                              QName secondChild,
                              int cmOp)

  Constructs a simple content model.

  Parameters:
    `firstChildIndex` - The first child index
    `cmOp` - The content model operator.
  See Also:
    `XMLContentSpec`

### SimpleContentModel

    public SimpleContentModel(QName firstChild,
                              QName secondChild,
                              int cmOp,
                              boolean dtd)

  Constructs a simple content model.

  Parameters:
    `firstChildIndex` - The first child index
    `cmOp` - The content model operator.
  See Also:
    `XMLContentSpec`

Method Detail

### validateContent

    public int validateContent(QName[] children,
                               int offset,
                               int length)
                        throws java.lang.Exception

  Check that the specified content is valid according to this content model. This method can also be called to do 'what if' testing of content models just to see if they would be valid.

  A value of -1 in the children array indicates a PCDATA node. All other indexes will be positive and represent child elements. The count can be zero, since some elements have the EMPTY content model and that must be confirmed.

  Specified by:
    validateContent in interface XMLContentModel

  Parameters:
    `children` - The children of this element. Each integer is an index within the `StringPool` of the child element name. An index of -1 is used to indicate an occurrence of non-whitespace character data.
    `offset` - Offset into the array where the children starts.
    `length` - The number of entries in the `children` array.
  Returns:
    The value -1 if fully valid, else the 0 based index of the child that first failed. If the value returned is equal to the number of children, then the specified children are valid but additional content is required to reach a valid ending state.
  Throws:
    java.lang.Exception - Thrown on error.

### validateContent

    public int validateContent(QName[] children,
                               int offset,
                               int length,
                               boolean incomplete,
                               int depth)
                        throws java.lang.Exception

  Specified by:
    validateContent in interface XMLContentModel

### checkLastChildEndingState

    public boolean checkLastChildEndingState()

  Specified by:
    checkLastChildEndingState in interface XMLContentModel

### validateContentSpecial

    public int validateContentSpecial(QName[] children,
                                      int offset,
                                      int length)
                               throws java.lang.Exception

  Specified by:
    validateContentSpecial in interface XMLContentModel

### setEquivClassComparator

    public void setEquivClassComparator(EquivClassComparator comparator)

  Specified by:
    setEquivClassComparator in interface XMLContentModel

### whatCanGoHere

    public int whatCanGoHere(boolean fullyValid,
                             InsertableElementsInfo info)
                      throws java.lang.Exception

  Returns information about which elements can be placed at a particular point in the passed element's content model.

  Note that the incoming content model to test must be valid at least up to the insertion point. If not, then -1 will be returned and the info object will not have been filled in.

  If, on return, the info.isValidEOC flag is set, then the 'insert after' element is a valid end of content. In other words, nothing needs to be inserted after it to make the parent element's content model valid.

  Specified by:
    whatCanGoHere in interface XMLContentModel

  Parameters:
    `fullyValid` - Only return elements that can be inserted and still maintain the validity of subsequent elements past the insertion point (if any). If the insertion point is at the end, and this is true, then only elements that can be legal final states will be returned.
    `info` - An object that contains the required input data for the method, and which will contain the output information if successful.
  Returns:
    The value -1 if fully valid, else the 0 based index of the child that first failed before the insertion point. If the value returned is equal to the number of children, then the specified children are valid but additional content is required to reach a valid ending state.
  See Also:
    `InsertableElementsInfo`

### getContentLeafNameTypeVector

    public ContentLeafNameTypeVector getContentLeafNameTypeVector()

  Specified by:
    getContentLeafNameTypeVector in interface XMLContentModel

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at http://e-docs.bea.com/wls/docs60
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD